<?php

	// Empeche la lecture directe du fichier
	// *************************************
	if ( ! defined( 'ABSPATH' ) ) exit;

	function geotools_creation_trackable(){
	
	// Trackable Personnalisé Verturin
	// Version 1.05

	// Recuperation des valeurs du widget
	// **********************************
	
	// Gestion du Trackable
	$geotools_codetrackable 			= trim(get_option('geotoolsTBNumber')); 
	$geotools_affichagecodetrackable 	= 'Code : '.$geotools_codetrackable;
	
	// Chemin d'enregistrement fixes
	// *****************************
	
	$cheminfichiertxt = (GEOTOOLS_PLUGIN_DIR.'/trackable/'.$geotools_codetrackable.'profiltrackable.txt');;
	$cheminimage = (GEOTOOLS_PLUGIN_DIR.'/trackable/');
	$cheminimageh = (GEOTOOLS_PLUGIN_DIR_PATH.'/trackable/');
	
	
	// Chemin vers notre fichier de police ttf
	// ***************************************

	$lienfontarial		= GEOTOOLS_PLUGIN_DIR.'/fonts/arial.ttf';
	$font_file 			= $lienfontarial;	
	
	// Chemin vers les fichiers fixes
	// ******************************

	$lienimagefond		= GEOTOOLS_PLUGIN_DIR_PATH.'/trackable/GEOTOOLS-background.png';
	$imagefond			= imagecreatefrompng($lienimagefond);

	// *************************************************
	// Recuperation du code source de la page geocaching
	// *************************************************

	// On Efface l'ancien fichier profiltrackable.txt 
	// **********************************************
	$fichierprofil = $cheminimage.$geotools_codetrackable.'profiltrackable.txt';
	if( file_exists ( $fichierprofil)) unlink( $fichierprofil ) ;	

	// Creation du nouveau fichier profiltrackable.txt
	// ***********************************************
	$urltrackable = 'https://www.geocaching.com/track/details.aspx?tracker='.$geotools_codetrackable;	
	$contenua = file_get_contents($urltrackable);
	$contenub = htmlspecialchars($contenua);
	$remplace = array('div', 'lt', 'quot',';','&','$');
	$contenu = strip_tags(str_replace($remplace, ' ', $contenub));
	$h = fopen(($cheminimage.$geotools_codetrackable.'profiltrackable.txt'), "a");
	fwrite($h, $contenu);
	fclose($h);
	
	$motmiles	= 'History';
	$motgif 	= 'TravelBugHeaderIcon';
	$motnom 	= '('.$geotools_codetrackable.')';
	
    $existemiles = FALSE;
	$existegif = FALSE;
	$existenom = FALSE;

	// Cherche les Miles du Trackable
    @ $fp = fopen($cheminfichiertxt, 'r') or die('Ouverture en lecture de "' . $cheminfichiertxt . '" impossible !');
    while (!feof($fp) && !$existemiles) {
        $lignemiles = fgets($fp, 1024);
        if (preg_match('|\b' . $motmiles . '\b|i', $lignemiles)) {			
            $existemiles = TRUE;
        }
    }
    fclose($fp);

	// Cherche le Gif du Trackable	
    @ $fpa = fopen($cheminfichiertxt, 'r') or die('Ouverture en lecture de "' . $cheminfichiertxt . '" impossible !');
    while (!feof($fpa) && !$existegif) {
        $lignegif = fgets($fpa, 1024);
        if (preg_match('|\b' . $motgif. '\b|i', $lignegif)) {

		$existegif = TRUE;
        }
    }
    fclose($fpa);

	// Cherche le nom du Trackable	
    @ $fpb = fopen($cheminfichiertxt, 'r') or die('Ouverture en lecture de "' . $cheminfichiertxt . '" impossible !');
    while (!feof($fpb) && !$existenom) {
        $lignenom = fgets($fpb, 1024);
        if (preg_match('|\b' . $motnom. '\b|i', $lignenom)) {

		$existenom = TRUE;
        }
    }
    fclose($fpb);

	// Transforme des lignes Name HTML en Texte
	// *****************************************
	$nametrackable 	= strip_tags($lignenom);
	$nametrackable1 = trim(strstr($nametrackable,' '));
	$nametrackable2 = trim(strstr($nametrackable1,' - ',true));	
	$nametrackable3 = trim(strstr($nametrackable1,'- '));		
	$nametrackable4 = trim(stristr($nametrackable3,' '));	
	
	$typetrackable = trim($nametrackable2);
	$nametrackableuser = trim($nametrackable4);
	
	// Transforme des lignes gif HTML en Avatar
	// ****************************************

	$namegif = strip_tags($lignegif);
	$namegif1 = trim(strstr($namegif,'/images'));		
	$namegif2 = trim(strstr($namegif1,'.gif',true));			

	// *************************
	// Creation du fichier image
	// *************************

	// Avatar Trackable
	// ****************
	
	// Lien avatar trackable GC
	$avatartrackable1 = 'https://www.geocaching.com'.$namegif2.'.gif';

	// Verifie si le fichier existe deja et le cree si besoin
	// ******************************************************

	$imageextensionTB 	= '.png';
	$imageextensionGIF 	= '.gif';

	// Enregistre l'image avatar du Trackable
	// **************************************
	
	$geotools_imagetrackable = imagecreatefromgif($avatartrackable1);
	$geotools_pathimagetrackable = GEOTOOLS_PLUGIN_DIR.'/trackable/'.$geotools_codetrackable.$imageextensionGIF;
	imagegif($geotools_imagetrackable, $geotools_pathimagetrackable);
	$avatartrackable = imagecreatefromgif(GEOTOOLS_PLUGIN_DIR_PATH.'/trackable/'.$geotools_codetrackable.$imageextensionGIF);
	
	// Transforme des lignes Miles HTML en Texte
	// *****************************************
	$founds = strip_tags($lignemiles);
	$foundsnombreb = trim(preg_replace('`[^[0-9]]`s' , '' , $founds)); 	
	$foundsnombreb1 = str_replace(' ', 'X', $foundsnombreb);	
	$foundsnombreb2 = str_replace('(', 'T', $foundsnombreb1);		
	$foundsnombreb3 = str_replace(')', 'T', $foundsnombreb2);		
	$foundsnombreb4 = trim(strstr($foundsnombreb3,'mi',true));
	$foundsnombreb5 = trim(strstr($foundsnombreb4,'XT'));
	$foundsnombreb6 = str_replace('X', '0', $foundsnombreb5);		
	$foundsnombreb7 = str_replace('T', '0', $foundsnombreb6);		

	$foundsnombrea = trim(strstr($founds,'i)',true));
	$caches = strip_tags($lignegif);
	$cachesnombre = trim(strstr($caches,' hides',true));

	
	$TBunitsAffichage = get_option('geotools_TBMilles');	
	
	switch($TBunitsAffichage){
	
		case 'tb-units01':
		// Milles
		$foundsnombremi = round($foundsnombreb7,2); // En milles	
		$milestrackable = __('Distance : ', 'geo-tools').$foundsnombremi. __(' mi', 'geo-tools');			
		break;
		
		case 'tb-units02':
		// Kilometres

		$foundsnombrekms = round(($foundsnombreb7/1.609),2); // En Kilometres			
		$milestrackable = __('Distance : ', 'geo-tools').$foundsnombrekms. __(' kms', 'geo-tools');			
		break;
	}
	
	// *********************************
	// Tout OK en dessous de ces lignes
	// *********************************
	
	// Position de l'avatar sur l'image finaltrackablee par rapport a angle Haut Gauche
	// Largeur Image finaltrackable : 200 pixels
	// Hauteur Image finaltrackable :  50 pixels

	$positionx = 1;
	$positiony = 1;

	// Calcul de la taille de l'image sur laquelle, on va placer le logo
	$largeurimagefond = imagesx($imagefond);
	$hauteurimagefond = imagesy($imagefond);
 
	//Calcul de l'image du logo
	$largeurW = imagesx($avatartrackable);
	$hauteurW = imagesy($avatartrackable);
 
	// Si l'image source est plus large que celle du avatar, on effectue la mise en place du avatar
	if($largeurimagefond > $largeurW)
{
	# Création de l'image finaltrackablee aux dimensions de l'image qui va accueillir le avatar
	$finaltrackable     = imagecreatetruecolor($largeurimagefond,$hauteurimagefond);
	# configuration du canal alpha pour le avatar
	imagealphablending($avatartrackable,false);
	imagesavealpha($avatartrackable,true);

	# Création de l'image finaltrackablee
	imagecopyresampled($finaltrackable,$imagefond,0,0,0,0,$largeurimagefond,$hauteurimagefond,$largeurimagefond,$hauteurimagefond);
	# Ajout du watermark
  
	// Couleur du Texte
	$text_color = imagecolorallocate($finaltrackable, 0, 0, 0); //blacky
	$text_taille = 8;
	// Ajout du texte au dessus des stats
	imagefttext($finaltrackable, $text_taille, 0, 54, 13, $text_color, $font_file, $nametrackableuser);
	// Ajout du texte au dessous des stats
	imagefttext($finaltrackable, $text_taille, 0, 54, 29, $text_color, $font_file, $geotools_affichagecodetrackable);
	// Ajout du texte au dessous des stats
	imagefttext($finaltrackable, $text_taille, 0, 54, 46, $text_color, $font_file, $milestrackable);
	
	// Compilation des images
	//imagecopyresampled($finaltrackable,$avatartrackable,$positionx,$positiony,0,0,$largeurWF,$hauteurWF,$largeurW,$hauteurW);
	// icones 32x32 devient 48x48
	imagecopyresampled($finaltrackable,$avatartrackable,$positionx,$positiony,0,0,48,48,$largeurW,$hauteurW);	

	// Affichage de l'image finaltrackablee
	//header("Content-type: image/png");

	//$imagefinal = imagecreatefrompng(GEOTOOLS_PLUGIN_DIR_PATH.'/images/'.$geotools_codetrackable.'tb'.$imageextensionTB);	
	//$imagefinal = imagecreatefromgif($geotools_codetrackable.'tb'.$imageextensionTB);	

	$lienimagefinal		= GEOTOOLS_PLUGIN_DIR.'/trackable/'.$geotools_codetrackable.'tb'.$imageextensionTB;		
	imagepng($finaltrackable,$lienimagefinal); //enregistre l'image 

	//imagepng($finaltrackable,$geotools_codetrackable.'tb'.$imageextensionTB); //enregistre l'image 
	//imagepng($finaltrackable);  	// affihce l'image
}
}	

?>